/*
 * SQLExecutionListener.java
 *
 * Created on 19 de julio de 2002, 10:22
 */

package frames;
import java.awt.event.*;
import java.lang.*;
import frames.*;

/**
 *
 * @author  nestor
 */
public class SQLExecutionListener implements ActionListener {
    public static final String AC_CLOSE = "close";
    public static final String AC_EXECUTE = "execute";
    public static final String AC_EXECUTE_ALL = "execute_all";
    public static final String AC_OPEN_FILE = "open_file";
    public static final String AC_SAVE_FILE = "save_file";
    public static final String AC_LOG_QUERYS = "log_query";
    public static final String AC_CANCEL_LOG = "log_cancel";
    public static final String AC_UNDO = "undo";
    public static final String AC_REDO = "redo";
    
    private SQLExecutionFrame frame = null;
    
    /** Creates a new instance of SQLExecutionListener */
    public SQLExecutionListener(SQLExecutionFrame _frame) {
        frame = _frame;
    }

    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
        if(actionEvent.getActionCommand().equals(AC_CLOSE)){
            frame.close();
        }
        if(actionEvent.getActionCommand().equals(AC_EXECUTE_ALL)){
            frame.executeAll();
        }
        if(actionEvent.getActionCommand().equals(AC_EXECUTE)){
            frame.execute();
        }
        if(actionEvent.getActionCommand().equals(AC_SAVE_FILE)){
            frame.saveFile();
        }
        if(actionEvent.getActionCommand().equals(AC_OPEN_FILE)){
            frame.openFile();
        }
        if(actionEvent.getActionCommand().equals(AC_LOG_QUERYS)){
            frame.initLog();
        }
        if(actionEvent.getActionCommand().equals(AC_CANCEL_LOG)){
            frame.cancelLog();
        }
        if(actionEvent.getActionCommand().equals(AC_UNDO)){
            frame.undo();
        }
        if(actionEvent.getActionCommand().equals(AC_REDO)){
            frame.redo();
        }
    }
}
