/*
 * GroupList.java
 *
 * Created on 31 de julio de 2002, 10:58
 */

package pgclibrary.treeObjects;
import pgclibrary.objects.*;
import java.sql.*;
import java.util.*;
import pgclibrary.dataaccess.*;

/**
 *
 * @author  nestor
 */
public class GroupList extends TreeInfo {
    
    /** Creates a new instance of GroupList */
    public GroupList(RootElement  source) {
        super(source);
        setIcon("./images/group.gif");
    }
    
    public long getOID() {
        return -3;
    }
    
    public void rebuildProperties() {
        removeAllProperties();
        try{
            PreparedStatement prep = getConnection().prepareStatement("SELECT OID FROM PG_GROUP");
            ResultSet rs = prep.executeQuery();
            while(rs.next()){
                addProperty(new Element(this, new Group(getDatabase(), rs.getLong("OID"))));
            }
            rs.close();
            prep.close();
        } catch (SQLException e){
        }
    }
    
    public String toString(){
        return "Groups";
    }
    
    public Database getDatabase(){
        return ((RootElement) getOwner()).getDatabase();
    }
}
